#!/bin/sh

MSG="Test 2 (all queries sequentially vs all queries in parallel)"
echo "$MSG" >> "$target"
echo "$MSG"
allqueries=`cat "${xml}".queries | grep -v '^#' | while read q query; do echo "'$query'"; done`
echo -n "Running all queries ... "
OUTPUTA="$xml".results/test2a_"$PACKAGE".xml
LOG="$xml".results/test2a_"$PACKAGE".log
echo -n "sequential ... "
echo "$allqueries" | xargs $BIN -s -d "$xml" -o "$OUTPUTA" > "$LOG" 2>&1
cat  "$LOG" | grep '^STATS' >> "$target"

OUTPUTB="$xml".results/test2b_"$PACKAGE".xml
LOG="$xml".results/test2b_"$PACKAGE".log
echo -n "parallel ... "
echo "$allqueries" | xargs $BIN -p -s -d "$xml" -o "$OUTPUTB" > "$LOG" 2>&1
cat  "$LOG" | grep '^STATS' >> "$target"
echo -n "Diff: " >> "$target"
if diff "$OUTPUTA" "$OUTPUTB" >/dev/null 2>&1; then
    echo ok
    echo ok >> "$target"
else
    echo failed
    echo failed >> "$target"
    exit 1
fi
echo '-------------------------------------------' >> "$target"
